--[[
	author: Zax
	content:
		globales: ASREM_
		functions: AspectReminder.
		XML: Asrem_
		XML UI: Asrem_ui_
		main frame: Asrem_ui_mainFrame
		event frame: Asrem_ui_mainFrame
		XML config: Asrem_cfg_
	todo : 
--]]

---------------------------------------------------------------------------------------
------------------------------------- VARIABLES ---------------------------------------
ASREM_NAME = "AspectReminder";
ASREM_VERS = GetAddOnMetadata(ASREM_NAME,"Version");
AspectReminder = {};
local ZaxLibMin = 1.0; -- version minimale requise de ZaxLib
ZAXLIB_NAME = ASREM_NAME; -- pour debug
local currentAspect = 0; -- init ID
local addonStatus = false; -- voir getter et setter pour acces depuis fichier config.xml
local enTest = false; -- /////

function AspectReminder.getLocal(key)
	----------- pour traduction (voir localization.lua) : ne pas deplacer !!!
	if (ASREM_LOCAL_TBL[key] == nil) then
		return key;
	else
		return ASREM_LOCAL_TBL[key];
	end;
end;

-------------------------------------------- aspects : ID des aspects /////
-- Aspect of the Hawk -- 13165
-- Aspect of the Fox -- 82661
-- Aspect of the Wild -- 20043
-- Aspect of the Cheetah -- 5118
-- Aspect of the Pack -- 13159

-- Aspect du faucon -- 13165
-- Aspect du renard -- 82661
-- Aspect de la nature -- 20043
-- Aspect du gupard -- 5118
-- Aspect de la meute -- 13159

-- WoW 5 Panda
-- Aspect of the Beast -- 61648
-- Aspect de la bte -- 61648
-- Aspect of the Iron Hawk -- 109260
-- Aspect du faucon de fer -- 109260
-- FOX et WILD partis

-- local name, rank, icon, cost, isFunnel, powerType, castTime, minRange, maxRange = GetSpellInfo(spellId ou spellName);
-- voir wowhead pour les IDs des sorts

local idMeute = 13159;
local listeAspects = {
	[0] = {
		["name"] = "none",
		["debugName"] = "default",
		["r"] = 0.4,
		["g"] = 0.4,
		["b"] = 0.4,
		["a"] = 0.5,
	},
	[13165] = {
		["name"] = AspectReminder.getLocal("Aspect of the Hawk"),
		["debugName"] = "hawk",
		["r"] = 0.3,
		["g"] = 0.3,
		["b"] = 1,
		["a"] = 0.5,
	},
	[82661] = {
		["name"] = AspectReminder.getLocal("Aspect of the Fox"),
		["debugName"] = "fox",
		["r"] = 0.7,
		["g"] = 0.7,
		["b"] = 0.7,
		["a"] = 0.5,
	},
	[20043] = {
		["name"] = AspectReminder.getLocal("Aspect of the Wild"),
		["debugName"] = "wild",
		["r"] = 0,
		["g"] = 0.7,
		["b"] = 0,
		["a"] = 0.5,
	},
	[5118] = {
		["name"] = AspectReminder.getLocal("Aspect of the Cheetah"),
		["debugName"] = "cheetah",
		["r"] = 0.8,
		["g"] = 0.8,
		["b"] = 0,
		["a"] = 0.4,
	},
	[61648] = {
		["name"] = AspectReminder.getLocal("Aspect of the Beast"),
		["debugName"] = "beast",
		["r"] = 0,
		["g"] = 0.7,
		["b"] = 0,
		["a"] = 0.5,
	},
	[109260] = {
		["name"] = AspectReminder.getLocal("Aspect of the Iron Hawk"),
		["debugName"] = "ironHawk",
		["r"] = 0.3,
		["g"] = 0.3,
		["b"] = 1,
		["a"] = 0.5,
	},
	[idMeute] = {
		["name"] = AspectReminder.getLocal("Aspect of the Pack"),
		["debugName"] = "pack",
		["r"] = 0.9,
		["g"] = 0,
		["b"] = 0.1,
		["a"] = 0.4,
	}
}

-------------------------------------------- saved et init
ASREM_SAVED = {};

function AspectReminder.initData()
	if (enTest) then ZaxLib:echo(ASREM_NAME.." === INIT DATA ==="); end;
	ASREM_SAVED = {};
	ASREM_SAVED["version"] = ASREM_VERS;
	ASREM_SAVED["inited"] = 0;
	ASREM_SAVED["visible"] = 1;
	ASREM_SAVED["locked"] = 0;
	ASREM_SAVED["width"] = 170;
	ASREM_SAVED["height"] = 90;
	ASREM_SAVED["posX"] = 250;
	ASREM_SAVED["posY"] = 350;
	
	------- couleurs par aspect
	ASREM_SAVED["colors"] = {};
	for key,value in pairs(listeAspects) do
		ASREM_SAVED["colors"][key] = {};
		ASREM_SAVED["colors"][key]["r"] = value["r"];
		ASREM_SAVED["colors"][key]["g"] = value["g"];
		ASREM_SAVED["colors"][key]["b"] = value["b"];
		ASREM_SAVED["colors"][key]["a"] = value["a"];
	end;
end

-------------------------------------------- graphisme cadre quand deverrouille
local frameMainCadre = {
	--bgFile = "Interface\\DialogFrame\\UI-DialogBox-Gold-Background",
	edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Gold-Border",
	tile = true,
	tileSize = 6,
	edgeSize = 6,
	insets = {
		left = 2,
		right = 2,
		top = 2,
		bottom = 2
	}
}

---------------------------------------------------------------------------------------
--------------------------------------- EVENTS ----------------------------------------
function AspectReminder.eventHandler(self,event,...)
	if (event == "VARIABLES_LOADED") then
		AspectReminder.chargement();
	elseif (event == "PLAYER_LOGOUT") then
		AspectReminder.saveSettings();
	elseif (event == "UNIT_AURA") then
		if (... == "player") then AspectReminder.changeCouleur(); end; -- event uniquement pour soi-meme
	end;
end

function AspectReminder.chargement()
	------------------------------- slash commands
	SlashCmdList["ASREM_CMD"] = AspectReminder.slashCmd;
		SLASH_ASREM_CMD1 = "/aspectreminder";
		SLASH_ASREM_CMD2 = "/asrem";
	
	------------------------------- validite
	if (not enTest) then
		local playerClass, englishClass = UnitClass("player");
		AspectReminder.setAddonStatus(englishClass == "HUNTER");
	else
		AspectReminder.setAddonStatus(true); -- toujours OK en test
	end;
	
	------------------------------- zaxlib
	if (ZAXLIB_VERS == nil or ZAXLIB_VERS < ZaxLibMin) then
		if (DEFAULT_CHAT_FRAME) then ChatFrame1:AddMessage(ASREM_NAME.." ERROR: ZaxLib v"..ZaxLib.." not loaded! "..ASREM_NAME.." will not properly work.",0.9,0.4,0.4); end;
	end;
	
	------------------------------- settings
	if (not ZaxLib:isEmpty(ASREM_SAVED)) then
		if (ASREM_SAVED["version"] ~= ASREM_VERS) then AspectReminder.initData(); end; --/////
	else
		AspectReminder.initData();
	end;
	if (enTest) then ZaxLib:echoTable(ASREM_SAVED,true,"   "); end;
	
	------------------------------- suite
	AspectReminder.constructionFrame();
	if (AspectReminder.getAddonStatus()) then
		ZaxLib:echo("|cFF7761A7"..ASREM_NAME.." "..ASREM_VERS.." |cFFCBA934"..AspectReminder.getLocal("loaded. Type /aspectreminder to display settings panel."));
	else
		ZaxLib:echo(ASREM_NAME.." "..AspectReminder.getLocal("works only for hunters... Go reroll!"),"red");
		Asrem_ui_mainFrame:Hide();
	end;
end

function AspectReminder.saveSettings()
	ASREM_SAVED["visible"] = ZaxLib:booleanToInt(Asrem_ui_mainFrame:IsVisible());
	--ASREM_SAVED["locked"] = ???;-- pas besoin ici : maj faite dans AspectReminder.verrouillage()
	Asrem_ui_mainFrame:Show(); -- affichage pour recuperation proprietes
	ASREM_SAVED["width"] = floor(Asrem_ui_mainFrame:GetWidth() + 0.5); -- le frame doit etre visible
	ASREM_SAVED["height"] = floor(Asrem_ui_mainFrame:GetHeight() + 0.5);
	ASREM_SAVED["posX"] = floor(Asrem_ui_mainFrame:GetLeft() + 0.5);
	ASREM_SAVED["posY"] = floor(Asrem_ui_mainFrame:GetBottom() + 0.5);
	
	ASREM_SAVED["inited"] = 1;
end

---------------------------------------------------------------------------------------
-------------------------------------- SLASH CMD --------------------------------------
function AspectReminder.slashCmd(arg)
	local taille = 0;
	local tblParams = ZaxLib:explode(arg," ",2);
	if (tblParams[1] ~= nil) then
		tblParams[1] = strlower(tblParams[1]);
		if (tblParams[1] == "width" or tblParams[1] == "w") then
			taille = ZaxLib:strToNumber(tblParams[2]);
			AspectReminder.modifTaille("width",taille);
		elseif (tblParams[1] == "height" or tblParams[1] == "h") then
			taille = ZaxLib:strToNumber(tblParams[2]);
			AspectReminder.modifTaille("height",taille);
		elseif (tblParams[1] == "show") then
			AspectReminder.setVisible(1);
		elseif (tblParams[1] == "hide") then
			AspectReminder.setVisible(0);
		elseif (tblParams[1] == "lock") then
			AspectReminder.verrouillage(1);
		elseif (tblParams[1] == "unlock") then
			AspectReminder.verrouillage(0);
		elseif (tblParams[1] == "reset") then
			AspectReminder.reset();
		elseif (tblParams[1] == "help") then
			AspectReminder.help();
		elseif (tblParams[1] == "test") then
			AspectReminder.fcnTest(tblParams[2]);
		elseif (tblParams[1] == "debug") then
			AspectReminder.toggleDebug();
		else
			ZaxLib:echo(ASREM_NAME.." ERROR: unknown parameter '"..tblParams[1].."'.","red");
		end;
	else
		AspectReminder.help();
	end;
end

---------------------------------------------------------------------------------------
--------------------------------------- ACTIONS ---------------------------------------
function AspectReminder.reset()
	AspectReminder.initData();
	AspectReminder.constructionFrame();
end

function AspectReminder.help()
	if (AspectReminder.getAddonStatus()) then
		InterfaceOptionsFrame_OpenToCategory(Asrem_cfg_frame);
	else
		ZaxLib:echo(ASREM_NAME.." "..AspectReminder.getLocal("works only for hunters... Go reroll!"),"red");
	end;
end

function AspectReminder.fcnTest(arg)
	-- liste des buffs amicaux du player
	ZaxLib:echo("--------------- liste des buffs","grey")
	local cpt = 1;
	local nomBuff, rank, icn, count, dtype, duration, expTime, unitCaster, isSteal, shouldCons, idBuff = UnitAura("player",cpt,"HELPFUL CANCELABLE"); -- buffs qui affecte uniquement le player
	while nomBuff do
		ZaxLib:echo(cpt.."-name:"..tostring(nomBuff).."--rank:"..tostring(rank).."--count:"..tostring(count).."--dtype:"..tostring(dtype).."--caster:"..tostring(unitCaster).."--"..tostring(shouldCons).."--id:"..tostring(idBuff).."--","grey");
		cpt = cpt + 1;
		nomBuff, rank, icn, count, dtype, duration, expTime, unitCaster, isSteal, shouldCons, idBuff = UnitAura("player",cpt,"HELPFUL CANCELABLE");
		if (cpt > 10) then
			ZaxLib:echo("LIMITE 10 ATTEINTE","grey");
			break;
		end;
	end;
	ZaxLib:echo("------------------------------","grey");
end

function AspectReminder.toggleDebug()
	enTest = not enTest;
	ZaxLib:echo(ASREM_NAME..": debug mode "..ZaxLib:booleanToStr(enTest)..".","orange");
end

function AspectReminder.setVisible(visible)
	if (AspectReminder.getAddonStatus()) then
		if (visible == nil) then visible = ZaxLib:inversionValeur(ZaxLib:booleanToInt(Asrem_ui_mainFrame:IsVisible())); end; -- toggle
		
		if (visible == 1) then
			Asrem_ui_mainFrame:Show();
			if (enTest) then ZaxLib:echo(ASREM_NAME.."===visible"); end;
		else
			Asrem_ui_mainFrame:Hide();
			if (enTest) then ZaxLib:echo(ASREM_NAME.."===hidden"); end;
		end;
	end;
end

function AspectReminder.verrouillage(verrou)
	if (AspectReminder.getAddonStatus()) then
		if (verrou == nil) then verrou = ZaxLib:inversionValeur(ASREM_SAVED["locked"]); end; -- toggle
		if (not Asrem_ui_mainFrame:IsVisible()) then Asrem_ui_mainFrame:Show(); end;
	
		if (verrou == 1) then ---------- verrouillage voulu
			ASREM_SAVED["locked"] = 1;
			Asrem_ui_mainFrame:SetScript("OnDragStart", nil);
			Asrem_ui_mainFrame:SetBackdrop(nil);
			Asrem_ui_handler:Hide();
			Asrem_ui_icn_pix:SetTexture(nil,false);
			
			if (enTest) then ZaxLib:echo(ASREM_NAME.."===locked==="); end;
		else --------------------------- deverrouillage voulu
			ASREM_SAVED["locked"] = 0;
			Asrem_ui_mainFrame:SetScript("OnDragStart", Asrem_ui_mainFrame.StartMoving);
			Asrem_ui_mainFrame:SetBackdrop(frameMainCadre);
			Asrem_ui_handler:Show();
			AspectReminder.setCouleurAspect(); -- affichage icone si non verrouille
			
			if (enTest) then ZaxLib:echo(ASREM_NAME.."===unlocked==="); end;
		end;
	end;
end

function AspectReminder.modifTaille(cote,taille) -- deprecated (poignee frame)
	if (AspectReminder.getAddonStatus()) then
		if (taille > 0) then
			if (not Asrem_ui_mainFrame:IsVisible()) then Asrem_ui_mainFrame:Show(); end;
			
			if (cote == "width") then
				Asrem_ui_mainFrame:SetWidth(taille);
			elseif (cote == "height") then
				Asrem_ui_mainFrame:SetHeight(taille);
			else
				ZaxLib:echo(ASREM_NAME.." ERROR: unknown size parameter '"..cote.."'.","red");
			end;
		else
			ZaxLib:echo(ASREM_NAME.." ERROR: bad width or height parameter value.","red");
		end;
	end;
end

---------------------------------------------------------------------------------------
------------------------------------ FCNS INTERNES ------------------------------------
function AspectReminder.constructionFrame()
	Asrem_ui_mainFrame:ClearAllPoints();
	Asrem_ui_mainFrame:SetPoint("BOTTOMLEFT",ASREM_SAVED["posX"],ASREM_SAVED["posY"]);
	Asrem_ui_mainFrame:SetWidth(ASREM_SAVED["width"]);
	Asrem_ui_mainFrame:SetHeight(ASREM_SAVED["height"]);
	
	AspectReminder.changeCouleur(); -- effectue automatiquement si lancement jeu mais pas si UI rechargee

	if (ASREM_SAVED["inited"] == 0) then -- 1er lancement
		ZaxLib:echo(ASREM_NAME.." "..AspectReminder.getLocal("is unlocked. Right-clic to lock the frame."),"yellow");	
		AspectReminder.verrouillage(0);
	else
		AspectReminder.verrouillage(1); -- toujours verrouille au demarrage, ne pas utiliser : AspectReminder.verrouillage(ASREM_SAVED["locked"]);
		if (ASREM_SAVED["visible"] == 0) then
			Asrem_ui_mainFrame:Hide();
		else
			Asrem_ui_mainFrame:Show();
		end;
	end;
end

---------------------------------------- getter et setter pour eviter une globale

function AspectReminder.getAddonStatus()
	return addonStatus;
end;

function AspectReminder.setAddonStatus(booleen)
	if (booleen) then addonStatus = true; else addonStatus = false; end;
end;

---------------------------------------------------------------------------------------
---------------------------------- CHANGEMENT ASPECT ----------------------------------
function AspectReminder.changeCouleur()
	if (AspectReminder.getAddonStatus()) then AspectReminder.setCouleurAspect(); end;
end

function AspectReminder.setCouleurAspect()
	local trouveAspect = "";
	local cpt = 1;
	local nomBuff, rank, icn, count, dtype, duration, expTime, unitCaster, isSteal, shouldCons, idBuff = UnitAura("player",cpt,"HELPFUL"); -- tous les buffs
	--------------------------------- boucle 1 : recherche de meute prioritaire (castee ou non par le player)
	while nomBuff do
		if (idBuff == idMeute) then
			Asrem_ui_mainFrame_Background:SetTexture(ASREM_SAVED["colors"][idBuff]["r"], ASREM_SAVED["colors"][idBuff]["g"], ASREM_SAVED["colors"][idBuff]["b"], ASREM_SAVED["colors"][idBuff]["a"]);
			if (ASREM_SAVED["locked"] == 0) then Asrem_ui_icn_pix:SetTexture(icn,false); end; -- affichage icone si non verrouille
			trouveAspect = cpt..":MEUTE de:"..unitCaster..":"..tostring(nomBuff).."(id="..tostring(idBuff).." debugName="..tostring(listeAspects[idBuff]["debugName"])..")";
			break;
		end;
		cpt = cpt + 1;
		nomBuff, rank, icn, count, dtype, duration, expTime, unitCaster, isSteal, shouldCons, idBuff = UnitAura("player",cpt,"HELPFUL");
		if (cpt > 25) then -- secu
			ZaxLib:echo(ASREM_NAME.." ERROR: too much recursion!","red");
			break;
		end;
	end;
	
	if (trouveAspect == "") then
		cpt = 1; -- reinit
		nomBuff, rank, icn, count, dtype, duration, expTime, unitCaster, isSteal, shouldCons, idBuff = UnitAura("player",cpt,"HELPFUL PLAYER"); -- n'afficher que ceux que le player peut caster
		--------------------------------- boucle 2 : recherche des aspects castes par le player
		while nomBuff do
			--if (enTest) then ZaxLib:echo("===     "..cpt..":"..tostring(nomBuff).."--"..tostring(rank).."--"..tostring(count).."--"..tostring(dtype).."--"..tostring(unitCaster).."--"..tostring(shouldCons).."--"..tostring(idBuff).."--","grey"); end; -- /////
			
			if (listeAspects[idBuff] ~= nil) then
				Asrem_ui_mainFrame_Background:SetTexture(ASREM_SAVED["colors"][idBuff]["r"], ASREM_SAVED["colors"][idBuff]["g"], ASREM_SAVED["colors"][idBuff]["b"], ASREM_SAVED["colors"][idBuff]["a"]);
				if (ASREM_SAVED["locked"] == 0) then Asrem_ui_icn_pix:SetTexture(icn,false); end; -- affichage icone si non verrouille
				trouveAspect = cpt..":::"..tostring(nomBuff).."(id="..tostring(idBuff).." debugName="..tostring(listeAspects[idBuff]["debugName"])..")";
				break;
			end;
			cpt = cpt + 1;
			nomBuff, rank, icn, count, dtype, duration, expTime, unitCaster, isSteal, shouldCons, idBuff = UnitAura("player",cpt,"HELPFUL PLAYER");
			if (cpt > 10) then -- secu
				ZaxLib:echo(ASREM_NAME.." ERROR: too much recursion!","red");
				break;
			end;
		end;
	end;

	if (trouveAspect == "") then
		idBuff = 0;
		Asrem_ui_mainFrame_Background:SetTexture(ASREM_SAVED["colors"][idBuff]["r"], ASREM_SAVED["colors"][idBuff]["g"], ASREM_SAVED["colors"][idBuff]["b"], ASREM_SAVED["colors"][idBuff]["a"]);
		Asrem_ui_icn_pix:SetTexture(nil,false);
		trouveAspect = tostring(nomBuff).."(id="..tostring(idBuff).." debugName="..tostring(listeAspects[idBuff]["debugName"])..")";
	end;
	
	if (enTest) then ZaxLib:echo(ASREM_NAME.." setCouleurAspect():"..trouveAspect.."---"); end;
	currentAspect = idBuff;
	if (currentAspect == nil) then currentAspect = 0; end; -- secu pour reloadUI()
end

---------------------------------------------------------------------------------------
------------------------------------- UI COULEURS -------------------------------------
function AspectReminder.afficheColorPicker()
	AspectReminder.ShowColorPicker(ASREM_SAVED["colors"][currentAspect]["r"], ASREM_SAVED["colors"][currentAspect]["g"], ASREM_SAVED["colors"][currentAspect]["b"], ASREM_SAVED["colors"][currentAspect]["a"], zax_colorPickerCallback);
end

function AspectReminder.ShowColorPicker(r, g, b, a, zax_colorPickerCallback)
	ColorPickerFrame:SetColorRGB(r,g,b);
	ColorPickerFrame.hasOpacity, ColorPickerFrame.opacity = (a ~= nil), a;
	ColorPickerFrame.previousValues = {r,g,b,a};
	ColorPickerFrame.func, ColorPickerFrame.opacityFunc, ColorPickerFrame.cancelFunc = AspectReminder.zax_colorPickerCallback, AspectReminder.zax_colorPickerCallback, AspectReminder.zax_colorPickerCallback;
	ColorPickerFrame:Hide(); -- Need to run the OnShow handler
	ColorPickerFrame:Show();
end

function AspectReminder.zax_colorPickerCallback(restore)
	local newR, newG, newB, newA;
	if (restore) then -- The user bailed, we extract the old color from the table created by ShowColorPicker
		newR, newG, newB, newA = unpack(restore);
	else -- Something changed
		newA, newR, newG, newB = OpacitySliderFrame:GetValue(), ColorPickerFrame:GetColorRGB();
	end;
	
	--------- update interne
	ASREM_SAVED["colors"][currentAspect]["r"], ASREM_SAVED["colors"][currentAspect]["g"], ASREM_SAVED["colors"][currentAspect]["b"], ASREM_SAVED["colors"][currentAspect]["a"] = newR, newG, newB, newA;
	--------- update de certains elements pour preview en temps reel, la sauvegarde reelle se fera sur AspectReminder.configOK()
	Asrem_ui_mainFrame_Background:SetTexture(ASREM_SAVED["colors"][currentAspect]["r"], ASREM_SAVED["colors"][currentAspect]["g"], ASREM_SAVED["colors"][currentAspect]["b"], ASREM_SAVED["colors"][currentAspect]["a"]);
end

---------------------------------------------------------------------------------------
-------------------------------------- UI CONFIG --------------------------------------
-- voir aussi <OnLoad> de ConfigFrame.xml
-- affichage direct du panneau de config : InterfaceOptionsFrame_OpenToCategory(xxxxxx_cfg_frame);

function AspectReminder.config(panel)
	panel.name = ASREM_NAME; -- Set the name for the Category for the Panel
	panel.okay = function (self) AspectReminder.configOK(); end; -- When the player clicks okay, run this function.
	panel.cancel = function (self) AspectReminder.configCancel(); end; -- When the player clicks cancel, run this function.
	panel.default = function (self) AspectReminder.configDefault(); end; -- When the player clicks the default button, run this function.
	--panel.refresh = function (self) AspectReminder.configRefresh(); end; -- This method will run when the Interface Options frame calls its OnShow function and after panel.default
	InterfaceOptions_AddCategory(panel); -- Add the panel to the Interface Options
end

function AspectReminder.configOK()
	--if (Asrem_cfg_frame:IsVisible()) then -- sinon, ca concerne pas cet addon
	-- unused : la sauvegarde est deja faite
end

function AspectReminder.configCancel()
	--if (Asrem_cfg_frame:IsVisible()) then -- sinon, ca concerne pas cet addon
	-- unused : la sauvegarde est deja faite
end

function AspectReminder.configDefault()
	if (Asrem_cfg_frame:IsVisible()) then -- sinon, ca concerne pas cet addon
		AspectReminder.reset();
		AspectReminder.configRefresh();
	end;
end

function AspectReminder.configRefresh()
	AspectReminder.updateBtnShow();
end

function AspectReminder.updateBtnShow()
	if (not AspectReminder.getAddonStatus()) then
		Asrem_cfg_show_Btn:Hide();
	else		
		if (Asrem_ui_mainFrame:IsVisible()) then
			Asrem_cfg_show_Btn:SetText(AspectReminder.getLocal("Hide frame"));
		else
			Asrem_cfg_show_Btn:SetText(AspectReminder.getLocal("Show frame"));
		end;
	end;
end

function AspectReminder.getHelpText()
	local tbl = {
		AspectReminder.getLocal("Right click to lock or unlock frame.").."\n\n",
		AspectReminder.getLocal("When unlocked, drag using left click to move frame."),
		AspectReminder.getLocal("When unlocked, ALT-click to change current aspect's color."),
	};
	local chaine = "";
	for index,value in ipairs(tbl) do
		chaine = chaine..value.."\n";
	end;
	return (string.sub(chaine, 1, -2));
end